Description

Member roles are incorrectly added when a user's memberships are updated on the user's Projects tab.

Setup:

2 Roles: R1 and R2

2 Groups: G1 and G2

G1 has role R1

G2 has roles R1 and R2

User is in groups G1 and G2

➔ that means the user has two inherited roles: R1 inherited by G1 and G2, and R2 inherited by G2

Steps to reproduce:

On the user's Projects tab click on Edit and then on Save without changing any checkboxes

Remove the user from G1 and G2

Expected result: The user no longer has any roles.

Actual result: The user still has the role R1.

Reason: When the user's memberships are saved, any roles inherited by more than one group are added as non-inherited roles.

Solution: Fix Member#role_ids=:

   def role_ids=(arg)

     ids = (arg || []).collect(&:to_i) - [0]

     # Keep inherited roles

-    ids += member_roles.select {|mr| !mr.inherited_from.nil?}.collect(&:role_id)

+    ids |= member_roles.select {|mr| !mr.inherited_from.nil?}.collect(&:role_id)

Related issues:

Related to Redmine - Patch #42572: Fix random test failure in MemberTest#test... Closed

Associated revisions

Revision 23449 - 2025-01-19 08:32 - Go MAEDA

Member roles are incorrectly added when a user's memberships are updated (#42106).

Patch by Thomas Löber (user:tloeber) and Mizuki ISHIKAWA (user:ishikawa999).

Revision 23456 - 2025-01-22 03:49 - Go MAEDA

Merged r23449 from trunk to 6.0-stable (#42106).

Revision 23457 - 2025-01-22 03:50 - Go MAEDA

Merged r23449 from trunk to 5.1-stable (#42106).

History

#1 - 2025-01-17 07:11 - Mizuki ISHIKAWA

- File add_test.diff added
I was able to reproduce the issue in my development environment as well.

When I apply the attached patch that adds a test and run the test, it fails with the current trunk code, as shown below.

# Running:

F

Failure:

MemberTest#test_update_roles_with_inherited_roles [test/unit/member_test.rb:86]:

--- expected

+++ actual

@@ -1 +1 @@

-[[1, 13], [1, 15], [2, 17], [3, nil]]

+[[1, 13], [1, 15], [2, 17], [3, nil], [1, nil]]

 The failure occurs because at the moment of calling test_user_member.set_editable_role_ids([3]), role1 inherited from the group is unexpectedly

assigned directly to the user.

When I modify the code based on the solution and then run the test, it passes successfully.

#2 - 2025-01-17 10:26 - Go MAEDA

- Status changed from New to Confirmed

- Target version set to 5.1.6

#3 - 2025-01-19 08:32 - Go MAEDA

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r23449. Thank you for your contribution.

#4 - 2025-01-22 03:50 - Go MAEDA

- Status changed from Confirmed to Closed

Merged the fix into the stable branches in r23456 and r23457.

#5 - 2025-04-12 04:22 - Go MAEDA

- Related to Patch #42572: Fix random test failure in MemberTest#test_update_roles_with_inherited_roles due to non-deterministic ordering added

Files

add_test.diff 1.95 KB 2025-01-17 Mizuki ISHIKAWA
